HDU 5742 - It's All In The Mind

题意:
    给出序列 a[] 的其中几项 ,已知序列满足非减,并且 0 <= ai <= 100, 问 (a1 + a2) / ( ∑ai)最大可能是多少
    
分析:
    保证 a1,a2尽可能大, 其余尽可能小即可

 1 #include <iostream>
 2 #include <cstring>
 3 using namespace std;
 4 int t, n, m;
 5 int a[105];
 6 int GCD(int a, int b)
 7 {
 8     return b == 0? a : GCD(b, a % b);
 9 }
10 int main()
11 {
12     scanf("%d", &t);
13     while (t--)
14     {
15         memset(a, -1, sizeof(a));
16         scanf("%d%d", &n, &m);
17         if (m == 0 || n == 2)
18         {
19             puts("1/1"); continue;
20         }
21         for (int i = 1; i <= m; i++)
22         {
23             int x, y;
24             scanf("%d%d", &x, &y);
25             a[x] = y;
26         }
27         int Min=0;
28         for (int i = n; i > 2; i--)
29         {
30             if (a[i] == -1) a[i] = Min;
31             else Min = a[i];
32         }
33         if (a[1] == -1) a[1] = 100;
34         if (a[2] == -1) a[2] = a[1];
35         int tu = a[1] + a[2], td = 0;
36         for (int i = 1; i <= n; i++) td += a[i];
37         int gcd = GCD(tu, td);
38         tu /= gcd;
39         td /= gcd;
40         printf("%d/%d\n", tu, td);
41     }
42 } 

HDU 5742 - It's All In The Mind

时间: 2024-12-22 10:45:33

HDU 5742 - It's All In The Mind的相关文章

HDU 5742 It&#39;s All In The Mind (贪心) 2016杭电多校联合第二场

题目:传送门. 题意:求题目中的公式的最大值,且满足题目中的三个条件. 题解:前两个数越大越好. #include <iostream> #include <algorithm> #include <cstdio> #include <cstring> using namespace std; int gcd(int a,int b) { if(!b) return a; return gcd(b,a%b); } int main() { int t; ci

多校2

A HDU 5734 t 组样例 n  n个数字 w[i]    b 是1或者 -1 求 min   1~n  sum(w[i]-a*b)^2 展开  1~n sum(w[i]^2) + a*a*n- 2*a*(w[1]*b1+w[2]*b2 ...); a>0  二次函数 a变量     最小  a= (w[1]*b1...)/n; 然后 求和  求一下gcd 就行  long long #include<stdio.h> #include<algorithm> #incl

【补题】组队训练第二场 &amp; 个人训练第一场

组队第二场: C题 CodeForces Gym 100735D 题意:给你N个木棍,问他们能拼成多少个三角形. 思路:从小到大排序,然后贪心地去取. 1 #include<cstdio> 2 #include<cstring> 3 #include<iostream> 4 #include<algorithm> 5 #include<cmath> 6 #include<vector> 7 #include<set> 8

2016 Multi-University Training Contest 2题解报告

A - Acperience HDU - 5734 题意: 给你一个加权向量,需要我们找到一个二进制向量和一个比例因子α,使得|W-αB|的平方最小,而B的取值为+1,-1,我们首先可以想到α为输入数据的平均值,考虑到是平方和,然后化简表达式,可以得到一个化简的式子,用n通分,可以做到没有除法,然后分子分母化简到互质. #define _CRT_SECURE_NO_WARNINGS #include<cstdio> #include<cstring> #include<iom

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是